from mlp import learn_once_cross_entropy
import numpy as np

def test_learn_once_cross_entropy():

    train = np.random.rand(100, 1000)
    targets = np.random.randint(10, size=100)

    d_in = train.shape[1]
    d_out = 10
    d_h = 4

    w1 = 2 * np.random.rand(d_in, d_h) - 1  # first layer weights
    b1 = np.zeros((1, d_h))                 # first layer biaises
    w2 = 2 * np.random.rand(d_h, d_out) - 1 # second layer weights
    b2 = np.zeros((1, d_out))               # second layer biaises

    w1, b1, w2, b2, loss = learn_once_cross_entropy(w1, b1, w2, b2, train, targets, learning_rate=0.01)

    assert (w1.shape, b1.shape, w2.shape, b2.shape) == ((d_in, d_h), (1, d_h), (d_h, d_out), (1, d_out))